# Правила работы с EUR

## Что такое EUR?

EUR - Elbrus User Repository - это пользовательский репозиторий открытых проектов для платформы Эльбрус. Проекты в EUR поддерживают сами пользователи. Проекты предоставлены **"as-is"** без гарантий работоспособности. Используйте с осторожностью.

EUR состоит из репозиториев Packages и Dockerhub.

Packages - репозиторий исходных кодов программ.

Dockerhub - репозиторий для Docker-образов. В его проектах должны присутствовать Dockerfile, из которых собираются образы. Владелец проекта может загрузить собранные образы в Gitlab Container Registry проекта.

Мейнтейнеры EUR оставляют за собой право удаления репозитория без уведомления владельца проекта при:
- нарушении лицензий на исходные коды владельцем проекта;
- наличии в проекте вредоносного ПО в исходном или бинарном виде;
- иных случаях, предусмотренных законом и иными правовыми актами.

## Зачем добавлять проекты в EUR?

Проект в персональной группе пользователя - его личная работа, которая может быть доступна всем. Она может быть завершенной, может функционировать с ошибками или не работать в целом.

Проект в EUR - работа, близкая к продукту. Это то, что проверено автором проекта на работоспособность и то, чем автор хочет явно поделиться с сообществом. В EUR собраны не только персональные проекты, но также и зеркала других репозиториев с указанием первоисточника.

Репозиторий EUR объединяет в себе работы сообщества для платформы Эльбрус.

## Как добавить свой проект в EUR?

Чтобы добавить проект в EUR, необходимо выполнить следующие шаги:
1. Создать проект, проверить работоспособность кодов, убедиться в наличии файлов README.md и LICENSE. По умолчанию все пользователи могут создавать проекты в своем **Namespace** (персональной группе, совпадающей с именем пользователя).
2. Открыть *Issue* на пользователя *eur_bot* в проекте [Правила работы с EUR](https://git.openelbrus.ru/eur/eur-rules/-/issues) с указанием ссылки на добавляемый проект.

После рассмотрения *Issue* мейнтейнер EUR создаст пустой проект в **Packages** или **Dockerhub** и добавит автора Issue в качестве владельца проекта. После этого автор проекта сможет добавить в него свои коды.

Как только все коды будут добавлены в проект EUR, пользователь может удалить проект в своем **Namespace**.

## Можно ли зеркалировать в EUR внешние проекты?

Да. Если проект поддерживается в Github или другой системе, его можно зеркалировать в EUR с указанием ссылки на оригинальный проект. Автор зеркала должен позаботиться о синхронизации зеркала с оригинальным проектом.

## Можно ли пользоваться Gitlab CI/CD?

Да. К проектам можно подключать собственных Gitlab агентов. Компиляцию кодов на Эльбрусе в рамках пайплайна агент может выполнить через ssh подключение на Эльбрус. Закрытый ключ для доступа по ssh может быть добавлен как CI/CD Variable проекта. Не забудьте отметить переменную как **Masked**, чтобы скрыть ключ в логах сборки!

## Разрешено ли использовать Gitlab Container/Package Registry и Git Large File Storage проекта?

Да. В Gitlab Container Registry хранятся Docker-образы, в Gitlab Package Registry - бинарные пакеты. Git LFS (Large File Storage) предназначен для хранения в проекте бинарных и прочих файлов, на которые нельзя получить diff с конкретными изменениями.

## Есть ли лимиты на размер репозиториев?

Да. Лимит на один репозиторий, включая все его файлы, Git LFS, Gitlab Container/Package Registry - **5 гигабайт**.

Максимальный размер единовременного пуша в репозиторий - 2 гигабайта.

## Как связаться с поддержкой?

По электронной почте support@openelbrus.ru